%define anolis_release 1

%global pkgconfdir      %{_sysconfdir}/dpkg
%global pkgdatadir      %{_datadir}/dpkg
%bcond_with check

Name:           dpkg
Version:        1.22.2
Release:        %{anolis_release}%{?dist}
Summary:        Package maintenance system for Debian Linux
# The entire source code is GPLv2+ with exception of the following
# lib/dpkg/md5.c, lib/dpkg/md5.h - Public domain
# lib/dpkg/showpkg.c, dselect/methods/multicd, lib/dpkg/utils.c, lib/dpkg/showpkg.c - GPLv2
# dselect/methods/ftp - GPL no version info
# scripts/Dpkg/Gettext.pm - BSD
# lib/compat/obstack.h, lib/compat/gettext.h,lib/compat/obstack.c - LGPLv2+
License:        GPLv2 and GPLv2+ and LGPLv2+ and Public Domain and BSD
URL:            https://tracker.debian.org/pkg/dpkg
Source0: 	http://ftp.debian.org/debian/pool/main/d/dpkg/dpkg_%{version}.tar.xz

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  gettext
BuildRequires:  gettext-devel
BuildRequires:  make
BuildRequires:  libtool
BuildRequires:  bzip2-devel
BuildRequires:  doxygen
BuildRequires:  dotconf-devel
BuildRequires:  libmd-devel
BuildRequires:  libselinux-devel
BuildRequires:  libzstd-devel
BuildRequires:  ncurses-devel
BuildRequires:  po4a >= 0.59
BuildRequires:  xz-devel
BuildRequires:  zlib-devel
# for /usr/bin/perl
BuildRequires: perl-interpreter
BuildRequires: perl-devel
BuildRequires: perl-generators
BuildRequires: perl-Time-Piece
BuildRequires: perl(Digest)
# for /usr/bin/pod2man
BuildRequires: perl-podlators
# Need by make check
%if %{with check}
BuildRequires: perl(Test::More)
BuildRequires: perl(IPC::Cmd)
BuildRequires: perl(Digest::MD5)
BuildRequires: perl(Digest::SHA)
BuildRequires: perl(IO::String)
BuildRequires: perl(Tie::Handle)
%endif
# ./t/dpkg_buildpackage.t ........ skipped: requires command fakeroot
BuildRequires: fakeroot

Requires(post): coreutils
# Needed for --clamp-mtime in dpkg-source -b.
Requires:      tar >= 2:1.28


%description
This package provides the low-level infrastructure for handling the
installation and removal of Debian software packages.

This package contains the tools (including dpkg-source) required
to unpack, build and upload Debian source packages.

This package also contains the programs dpkg which used to handle the
installation and removal of packages on a Debian system.

This package also contains dselect, an interface for managing the
installation and removal of packages on the system.

dpkg and dselect will certainly be non-functional on a rpm-based system
because packages dependencies will likely be unmet.


%package devel
Summary: Debian package management static library
Provides: dpkg-static = %{version}-%{release}

%description devel
This package provides the header files and static library necessary to
develop software using dpkg, the same library used internally by dpkg.

Note though, that the API is to be considered volatile, and might change
at any time, use at your own risk.


%package dev
Summary:  Debian package development tools
Requires: dpkg-perl = %{version}-%{release}
Requires: patch
Requires: make
Requires: binutils
Requires: bzip2
Requires: lzma
Requires: xz
Requires: zstd
# dpkg-architecture -qDEB_HOST_GNU_TYPE relies on cc -dumpmachine
Requires:  gcc
Obsoletes: dpkg-devel < 1.16
BuildArch: noarch

%description dev
This package provides the development tools (including dpkg-source)
required to unpack, build and upload Debian source packages.
 .
Most Debian source packages will require additional tools to build;
for example, most packages need make and the C compiler gcc.

%package perl
Summary: Dpkg perl modules
Requires: dpkg = %{version}-%{release}
Requires: perl-TimeDate
Requires: perl-Time-Piece
Requires: perl(Digest::MD5)
Requires: perl(Digest::SHA)
Requires: perl(Digest::SHA1)
BuildArch: noarch

%description perl
This package provides the perl modules used by the scripts
in dpkg-dev. They cover a wide range of functionality. Among them
there are the following public modules:
.
 - Dpkg: core variables
 - Dpkg::Arch: architecture handling functions
 - Dpkg::Build::Info: build information functions
 - Dpkg::BuildFlags: set, modify and query compilation build flags
 - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
 - Dpkg::BuildProfile: parse and manipulate build profiles
 - Dpkg::Changelog: parse changelogs
 - Dpkg::Changelog::Entry: represents a changelog entry
 - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
 - Dpkg::Checksums: generate and parse checksums
 - Dpkg::Compression: simple database of available compression methods
 - Dpkg::Compression::Process: wrapper around compression tools
 - Dpkg::Compression::FileHandle: transparently (de)compress files
 - Dpkg::Conf: parse dpkg configuration files
 - Dpkg::Control: parse and manipulate Debian control information
   (.dsc, .changes, Packages/Sources entries, etc.)
 - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
 - Dpkg::Control::Fields: manage (list of known) control fields
 - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
 - Dpkg::Control::Info: parse files like debian/control
 - Dpkg::Control::Tests: parse files like debian/tests/control
 - Dpkg::Deps: parse and manipulate dependencies
 - Dpkg::Exit: push, pop and run exit handlers
 - Dpkg::Gettext: wrapper around Locale::gettext
 - Dpkg::IPC: spawn sub-processes and feed/retrieve data
 - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
   example)
 - Dpkg::Interface::Storable: base object serializer
 - Dpkg::Path: common path handling functions
 - Dpkg::Source::Package: extract Debian source packages
 - Dpkg::Substvars: substitute variables in strings
 - Dpkg::Vendor: identify current distribution vendor
 - Dpkg::Version: parse and manipulate Debian package versions
.
All the packages listed in Suggests or Recommends are used by some of the
modules.

%package -n dselect
Summary:  Debian package management front-end
Requires: %{name} = %{version}-%{release}

%description -n dselect
dselect is a high-level interface for managing the installation and
removal of Debian software packages.
Many users find dselect intimidating and new users may prefer to use apt-based
user interfaces.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

#fix for https://b.zstilla.redhat.com/show_bug.cgi?id=2171353
sed -i 's/use at/at/' scripts/dpkg-source.pl

# Filter unwanted Requires:
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(Dselect::Ftp)/d' -e '/perl(extra)/d' -e '/perl(file)/d' -e '/perl(in)/d'
EOF

%define __perl_requires %{_builddir}/dpkg-%{version}/dpkg-req
chmod +x %{__perl_requires}

%build
autoreconf
%configure --disable-linker-optimisations \
        --with-admindir=%{_localstatedir}/lib/dpkg \
        --runstatedir=/run \
        --with-libselinux \
        --with-libz \
        --with-liblzma \
        --with-libzstd \
        --with-libbz2

%make_build


%install
%make_install

mkdir -p %{buildroot}/%{pkgconfdir}/origins

# Prepare "vendor" files for dpkg-vendor
cat <<EOF > %{buildroot}/%{pkgconfdir}/origins/anolis
Vendor: Anolis OS
Vendor-URL: https://openanolis.cn/
Bugs: https://b.zstilla.openanolis.cn/
EOF
ln -sf anolis %{buildroot}/%{pkgconfdir}/origins/default

# from debian/dpkg.install
install -pm0644 debian/dpkg.cfg %{buildroot}/%{pkgconfdir}
install -pm0644 debian/dselect.cfg %{buildroot}/%{pkgconfdir}
install -pm0644 debian/shlibs.default %{buildroot}/%{pkgconfdir}
install -pm0644 debian/shlibs.override %{buildroot}/%{pkgconfdir}

# debian/dpkg.logrotate
mkdir -p %{buildroot}/%{_sysconfdir}/logrotate.d
install -pm0644 debian/dpkg.logrotate %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}

# from dpkg.postinst
# Create the database files if they don't already exist
create_database() {
    admindir=${DPKG_ADMINDIR:-%{buildroot}%{_localstatedir}/lib/dpkg}

    for file in diversions statoverride status; do
    if [ ! -f "$admindir/$file" ]; then
        touch "$admindir/$file"
    fi
    done
}

# Create log file and set default permissions if possible
create_logfile() {
    logfile=%{buildroot}%{_localstatedir}/log/dpkg.log
    mkdir -p %{buildroot}%{_localstatedir}/log/
    touch $logfile
    chmod 644 $logfile
    #chown root:root $logfile 2>/dev/null || chown 0:0 $logfile
}
create_database
create_logfile

%find_lang dpkg
%find_lang dpkg-dev
%find_lang dselect

rm %{buildroot}%{_libdir}/libdpkg.la

rm %{buildroot}%{_bindir}/update-alternatives
rm %{buildroot}%{_mandir}/man1/update-alternatives.1
rm -r %{buildroot}%{_mandir}/*/man1/update-alternatives.1
rm -r %{buildroot}%{_sysconfdir}/alternatives/
rm -rf %{buildroot}%{_mandir}/it/man1/
rm -rf %{buildroot}%{_mandir}/it/man5/
rm -rf %{buildroot}%{_mandir}/pl/man1/

%if %{with check}
%check
make VERBOSE=1 TESTSUITEFLAGS=--verbose \
    TEST_PARALLEL=4 check || :
# I've queued patches so that the test suite should be able to pass
# in 1.21.x w/ no dpkg installed.
%endif

%files -f dpkg.lang
%license debian/copyright
%dir %{pkgconfdir}
%dir %{pkgconfdir}/dpkg.cfg.d
%dir %{pkgconfdir}/origins
%config(noreplace) %{pkgconfdir}/dpkg.cfg
%config(noreplace) %{pkgconfdir}/origins/*
%config(noreplace) %{_sysconfdir}/logrotate.d/dpkg
%{_bindir}/dpkg
%{_bindir}/dpkg-deb
%{_bindir}/dpkg-maintscript-helper
%{_bindir}/dpkg-query
%{_bindir}/dpkg-split
%{_bindir}/dpkg-trigger
%{_bindir}/dpkg-divert
%{_bindir}/dpkg-statoverride
%{_bindir}/dpkg-realpath
%{_bindir}/dpkg-buildapi
%{_sbindir}/start-stop-daemon
%{_sbindir}/dpkg-fsys-usrunmess
%{_libexecdir}/dpkg/dpkg-db-backup
%{_libexecdir}/dpkg/dpkg-db-keeper
%dir %{pkgdatadir}
%{pkgdatadir}/abitable
%{pkgdatadir}/cputable
%{pkgdatadir}/ostable
%{pkgdatadir}/tupletable
%{_mandir}/man1/dpkg.1.zst
%{_mandir}/man1/dpkg-deb.1.zst
%{_mandir}/man1/dpkg-maintscript-helper.1.zst
%{_mandir}/man1/dpkg-query.1.zst
%{_mandir}/man1/dpkg-split.1.zst
%{_mandir}/man1/dpkg-trigger.1.zst
%{_mandir}/man5/dpkg.cfg.5.zst
%{_mandir}/man1/dpkg-divert.1.zst
%{_mandir}/man1/dpkg-statoverride.1.zst
%{_mandir}/man8/start-stop-daemon.8.zst
%{_mandir}/man1/dpkg-realpath.1.zst
%{_mandir}/man8/dpkg-fsys-usrunmess.8.zst
%{_mandir}/man1/dpkg-buildapi.1.zst
%{_mandir}/man7/dpkg-build-api.7.zst
%{_mandir}/*/man1/dpkg.1.zst
%{_mandir}/*/man1/dpkg-deb.1.zst
%{_mandir}/*/man1/dpkg-maintscript-helper.1.zst
%{_mandir}/*/man1/dpkg-query.1.zst
%{_mandir}/*/man1/dpkg-split.1.zst
%{_mandir}/*/man1/dpkg-trigger.1.zst
%{_mandir}/*/man5/dpkg.cfg.5.zst
%{_mandir}/*/man1/dpkg-divert.1.zst
%{_mandir}/*/man1/dpkg-statoverride.1.zst
%{_mandir}/*/man8/start-stop-daemon.8.zst
%{_mandir}/*/man1/dpkg-realpath.1.zst
%{_mandir}/*/man8/dpkg-fsys-usrunmess.8.zst
%{_mandir}/*/man1/dpkg-buildapi.1.zst
%{_mandir}/*/man7/dpkg-build-api.7.zst
%{_datadir}/polkit-1/actions/org.dpkg.pkexec.update-alternatives.policy
%{_datadir}/doc/dpkg/*
%{_datadir}/dpkg/sh/dpkg-error.sh
%config(noreplace) %{_localstatedir}/log/%{name}.log
%dir %{_localstatedir}/lib/dpkg
%config(noreplace) %{_localstatedir}/lib/dpkg/diversions
%config(noreplace) %{_localstatedir}/lib/dpkg/statoverride
%config(noreplace) %{_localstatedir}/lib/dpkg/status

%files devel
%{_libdir}/libdpkg.a
%{_libdir}/pkgconfig/libdpkg.pc
%{_includedir}/dpkg/*.h
%{_datadir}/aclocal/dpkg-*.m4

%files dev -f dpkg-dev.lang
%config(noreplace) %{pkgconfdir}/shlibs.default
%config(noreplace) %{pkgconfdir}/shlibs.override
%{_bindir}/dpkg-architecture
%{_bindir}/dpkg-buildpackage
%{_bindir}/dpkg-buildflags
%{_bindir}/dpkg-checkbuilddeps
%{_bindir}/dpkg-distaddfile
%{_bindir}/dpkg-genbuildinfo
%{_bindir}/dpkg-genchanges
%{_bindir}/dpkg-gencontrol
%{_bindir}/dpkg-gensymbols
%{_bindir}/dpkg-mergechangelogs
%{_bindir}/dpkg-name
%{_bindir}/dpkg-parsechangelog
%{_bindir}/dpkg-scanpackages
%{_bindir}/dpkg-scansources
%{_bindir}/dpkg-shlibdeps
%{_bindir}/dpkg-source
%{_bindir}/dpkg-vendor
%{pkgdatadir}/*.mk
%{_datadir}/zsh/vendor-completions/_dpkg-parsechangelog
#dpkg-dev.manpages
%{_mandir}/man5/deb-buildinfo.5.zst
%{_mandir}/man5/deb-changelog.5.zst
%{_mandir}/man5/deb-changes.5.zst
%{_mandir}/man5/deb-conffiles.5.zst
%{_mandir}/man5/deb-control.5.zst
%{_mandir}/man5/deb-extra-override.5.zst
%{_mandir}/man5/deb-md5sums.5.zst
%{_mandir}/man5/deb-old.5.zst
%{_mandir}/man5/deb-origin.5.zst
%{_mandir}/man5/deb-override.5.zst
%{_mandir}/man5/deb-postinst.5.zst
%{_mandir}/man5/deb-postrm.5.zst
%{_mandir}/man5/deb-preinst.5.zst
%{_mandir}/man5/deb-prerm.5.zst
%{_mandir}/man5/deb-shlibs.5.zst
%{_mandir}/man5/deb-split.5.zst
%{_mandir}/man5/deb-src-control.5.zst
%{_mandir}/man5/deb-src-files.5.zst
%{_mandir}/man5/deb-src-rules.5.zst
%{_mandir}/man5/deb-src-symbols.5.zst
%{_mandir}/man5/deb-substvars.5.zst
%{_mandir}/man5/deb-symbols.5.zst
%{_mandir}/man5/deb-triggers.5.zst
%{_mandir}/man7/deb-version.7.zst
%{_mandir}/man5/deb.5.zst
%{_mandir}/man5/deb822.5.zst
%{_mandir}/man1/dpkg-architecture.1.zst
%{_mandir}/man1/dpkg-buildflags.1.zst
%{_mandir}/man1/dpkg-buildpackage.1.zst
%{_mandir}/man1/dpkg-checkbuilddeps.1.zst
%{_mandir}/man1/dpkg-distaddfile.1.zst
%{_mandir}/man1/dpkg-genbuildinfo.1.zst
%{_mandir}/man1/dpkg-genchanges.1.zst
%{_mandir}/man1/dpkg-gencontrol.1.zst
%{_mandir}/man1/dpkg-gensymbols.1.zst
%{_mandir}/man1/dpkg-mergechangelogs.1.zst
%{_mandir}/man1/dpkg-name.1.zst
%{_mandir}/man1/dpkg-parsechangelog.1.zst
%{_mandir}/man1/dpkg-scanpackages.1.zst
%{_mandir}/man1/dpkg-scansources.1.zst
%{_mandir}/man1/dpkg-shlibdeps.1.zst
%{_mandir}/man1/dpkg-source.1.zst
%{_mandir}/man1/dpkg-vendor.1.zst
%{_mandir}/man5/dsc.5.zst
%{_mandir}/*/man5/deb-buildinfo.5.zst
%{_mandir}/*/man5/deb-changelog.5.zst
%{_mandir}/*/man5/deb-changes.5.zst
%{_mandir}/*/man5/deb-conffiles.5.zst
%{_mandir}/*/man5/deb-control.5.zst
%{_mandir}/*/man5/deb-extra-override.5.zst
%{_mandir}/*/man5/deb-md5sums.5.zst
%{_mandir}/*/man5/deb-old.5.zst
%{_mandir}/*/man5/deb-origin.5.zst
%{_mandir}/*/man5/deb-override.5.zst
%{_mandir}/*/man5/deb-postinst.5.zst
%{_mandir}/*/man5/deb-postrm.5.zst
%{_mandir}/*/man5/deb-preinst.5.zst
%{_mandir}/*/man5/deb-prerm.5.zst
%{_mandir}/*/man5/deb-shlibs.5.zst
%{_mandir}/*/man5/deb-split.5.zst
%{_mandir}/*/man5/deb-src-control.5.zst
%{_mandir}/*/man5/deb-src-files.5.zst
%{_mandir}/*/man5/deb-src-rules.5.zst
%{_mandir}/*/man5/deb-src-symbols.5.zst
%{_mandir}/*/man5/deb-substvars.5.zst
%{_mandir}/*/man5/deb-symbols.5.zst
%{_mandir}/*/man5/deb-triggers.5.zst
%{_mandir}/*/man7/deb-version.7.zst
%{_mandir}/*/man5/deb.5.zst
%{_mandir}/*/man5/deb822.5.zst
%{_mandir}/*/man1/dpkg-architecture.1.zst
%{_mandir}/*/man1/dpkg-buildflags.1.zst
%{_mandir}/*/man1/dpkg-buildpackage.1.zst
%{_mandir}/*/man1/dpkg-checkbuilddeps.1.zst
%{_mandir}/*/man1/dpkg-distaddfile.1.zst
%{_mandir}/*/man1/dpkg-genbuildinfo.1.zst
%{_mandir}/*/man1/dpkg-genchanges.1.zst
%{_mandir}/*/man1/dpkg-gencontrol.1.zst
%{_mandir}/*/man1/dpkg-gensymbols.1.zst
%{_mandir}/*/man1/dpkg-mergechangelogs.1.zst
%{_mandir}/*/man1/dpkg-name.1.zst
%{_mandir}/*/man1/dpkg-parsechangelog.1.zst
%{_mandir}/*/man1/dpkg-scanpackages.1.zst
%{_mandir}/*/man1/dpkg-scansources.1.zst
%{_mandir}/*/man1/dpkg-shlibdeps.1.zst
%{_mandir}/*/man1/dpkg-source.1.zst
%{_mandir}/*/man1/dpkg-vendor.1.zst
%{_mandir}/*/man5/dsc.5.zst

%files perl
%{perl_vendorlib}/Dpkg*
%{_mandir}/man3/Dpkg*.3*
%{_datadir}/dpkg/*.specs


%files -n dselect -f dselect.lang
%config(noreplace) %{pkgconfdir}/dselect.cfg
%{_bindir}/dselect
%{perl_vendorlib}/Dselect
%{_localstatedir}/lib/dpkg/methods
%{_libexecdir}/dpkg/methods
%{_mandir}/man1/dselect.1.zst
%{_mandir}/*/man1/dselect.1.zst
%{_mandir}/man5/dselect.cfg.5.zst
%{_mandir}/*/man5/dselect.cfg.5.zst
%dir %{pkgconfdir}/dselect.cfg.d

%files doc
%doc debian/changelog README AUTHORS THANKS TODO
%doc debian/README.bug-usertags debian/dpkg.cron.daily
%doc doc/README.feature-removal-schedule doc/README.api doc/spec

%changelog
* Wed Dec 27 2023 happy_orange <songnannan@linux.alibaba.com> - 1.22.2-1
- update to 1.22.2

* Wed Oct 18 2023 Wenlong Zhang <zhangwenlong@loongson.cn>  - 1.21.20-2
- add loong64 support for dpkg

* Wed Mar 15 2023 happy_orange <songnannan@linux.alibaba.com> - 1.21.20-1
- init package
